import 'package:auto_route/auto_route.dart';
import 'package:cpt_main/modules/home/property_news/item_list_news.dart';
import 'package:cpt_main/router/page/main_page_router.dart';
import 'package:flutter/material.dart';
import 'package:flutter_hooks/flutter_hooks.dart';
import 'package:hooks_riverpod/hooks_riverpod.dart';
import 'package:router/ext/auto_router_extensions.dart';
import 'package:shared/utils/log_utils.dart';
import 'package:widgets/ext/ex_widget.dart';
import 'package:widgets/load_state_layout.dart';
import 'package:widgets/widget_export.dart';

import '../item_latest_news.dart';
import 'latest_news_info_view_model.dart';

@RoutePage()
class LatestNewsInfoScreen extends HookConsumerWidget {
  static void startInstance({BuildContext? context}) {
    if (context != null) {
      context.router.push(const LatestNewsInfoPageRoute());
    } else {
      appRouter.push(const LatestNewsInfoPageRoute());
    }
  }

  @override
  Widget build(BuildContext context, WidgetRef ref) {
    final viewModel = ref.read(latestNewsInfoViewModelProvider.notifier);
    final state = ref.watch(latestNewsInfoViewModelProvider);

    useEffect(() {
      // 组件挂载时执行 - 执行接口请求
      Future.microtask(() => viewModel.fetchList());
      return () {
        // 组件卸载时执行
      };
    }, []);

    return Container(
      width: double.infinity,
      height: double.infinity,
      child: EasyRefresh(
        controller: viewModel.refreshController,
        onRefresh: viewModel.onRefresh,
        onLoad: viewModel.loadMore,
        child: LoadStateLayout(
          state: state.loadingState,
          errorMessage: state.errorMessage,
          errorRetry: () {
            viewModel.retryRequest();
          },
          successSliverWidget: [
            SliverList(
                delegate: SliverChildBuilderDelegate(
              (context, index) {
                return LatestNewsItem(index: index, item: state.datas[index]).onTap((){
                  viewModel.gotoLatestNewsDetail(context,state.datas[index]);
                });
              },
              childCount: state.datas.length,
            ))
          ],
        ),
      ).marginOnly(top: 5, bottom: 5),
    );
  }
}
